from src.unmeshed.sdk.decorators.worker_function import worker_function
from src.unmeshed.sdk.common.work_request import WorkRequest
from src.unmeshed.sdk.common.work_context import WorkContext


@worker_function(name = "worker1", max_in_progress= 3)
def worker1(inp : str):
    work_request : WorkRequest = WorkContext.current_work_request()
    print("Process Id : " + str(work_request.get_process_id()) + " and step Id : " + str(work_request.get_step_id()) + " for worker : worker1")
    return {
        "me": "Testing locally"
    }

@worker_function(name = "secret_state_worker")
def secret_state_worker(inp: str):
    work_request : WorkRequest = WorkContext.current_work_request()
    print("Process Id : " + str(work_request.get_process_id()) + " and step Id : " + str(work_request.get_step_id()) + "for worker : secret_state_worker")
    return {
        "__secretStatePut": {
            "abc": "test",
            "booleanTest": True,
            "integerVar": 20,
            "nested": {
                "abc": "testing123"
            }
        }
    }