from typing import Callable

class Worker:
    def __init__(self, execution_method: Callable, name: str):
        self.execution_method = execution_method
        self.name = name
        self.namespace = "default"
        self.max_in_progress = 1
        self.io_thread = False

    def set_namespace(self, namespace : str):
        self.namespace = namespace

    def get_namespace(self) -> str:
        return self.namespace

    def set_max_in_progress(self, max_in_progress : int):
        self.max_in_progress = max_in_progress

    def get_max_in_progress(self) -> int:
        return self.max_in_progress

    def set_io_thread(self, io_thread: bool):
        self.io_thread = io_thread

    def is_io_thread(self) -> bool:
        return self.io_thread

    def set_execution_method(self, _execution_method):
        self.execution_method = _execution_method
    
    def get_execution_method(self) -> Callable:
        return self.execution_method

    def set_name(self, _name):
        self.name = _name

    def get_name(self) -> str:
        return self.name

    def __repr__(self) -> str:
        return f"Worker(name={self.name}, execution_method={self.execution_method})"