from dataclasses import dataclass, field
from typing import Any, Optional

from .step_queue_name_data import StepQueueNameData

@dataclass
class PollRequestData:
    _stepQueueNameData: Optional[StepQueueNameData] = field(default=None)
    _size: Optional[int] = field(default=0)

    def __init__(self, stepQueueNameData: StepQueueNameData, size: int):
        self._stepQueueNameData = stepQueueNameData
        self._size = size

    @property
    def stepQueueNameData(self) -> StepQueueNameData:
        return self._stepQueueNameData

    @stepQueueNameData.setter
    def stepQueueNameData(self, value: StepQueueNameData) -> None:
        self._stepQueueNameData = value

    @property
    def size(self) -> int:
        return self._size

    @size.setter
    def size(self, value: int) -> None:
        self._size = value

    def to_dict(self) -> dict[str, Any]:
        return {
            "stepQueueNameData": self._stepQueueNameData,
            "size": self._size
        }