import time
from dataclasses import dataclass, field

from .unmeshed_constants import UnmeshedConstants


@dataclass
class ProcessSearchRequest:
    start_time_epoch: int = field(default_factory=lambda: int((time.time() - (60 * 60 * 24)) * 1000))
    end_time_epoch: int = None
    namespace: str = 'default'
    process_types: list['UnmeshedConstants.ProcessType'] = field(default_factory=list)
    trigger_types: list['UnmeshedConstants.ProcessTriggerType'] = field(default_factory=list)
    names: list[str] = field(default_factory=list)
    process_ids: list[int] = field(default_factory=list)
    correlation_ids: list[str] = field(default_factory=list)
    request_ids: list[str] = field(default_factory=list)
    statuses: list['UnmeshedConstants.ProcessStatus'] = field(default_factory=list)
    limit: int = 10
    offset: int = 0

    def get_start_time_epoch(self) -> int:
        return self.start_time_epoch

    def set_start_time_epoch(self, start_time_epoch: int):
        self.start_time_epoch = start_time_epoch

    def get_end_time_epoch(self) -> int:
        return self.end_time_epoch

    def set_end_time_epoch(self, end_time_epoch: int):
        self.end_time_epoch = end_time_epoch

    def get_namespace(self) -> str:
        return self.namespace

    def set_namespace(self, namespace: str):
        self.namespace = namespace

    def get_process_types(self) -> list:
        return self.process_types

    def set_process_types(self, process_types: list):
        self.process_types = process_types

    def get_trigger_types(self) -> list:
        return self.trigger_types

    def set_trigger_types(self, trigger_types: list):
        self.trigger_types = trigger_types

    def get_names(self) -> list:
        return self.names

    def set_names(self, names: list):
        self.names = names

    def get_process_ids(self) -> list:
        return self.process_ids

    def set_process_ids(self, process_ids: list):
        self.process_ids = process_ids

    def get_correlation_ids(self) -> list:
        return self.correlation_ids

    def set_correlation_ids(self, correlation_ids: list):
        self.correlation_ids = correlation_ids

    def get_request_ids(self) -> list:
        return self.request_ids

    def set_request_ids(self, request_ids: list):
        self.request_ids = request_ids

    def get_statuses(self) -> list:
        return self.statuses

    def set_statuses(self, statuses: list):
        self.statuses = statuses

    def get_limit(self) -> int:
        return self.limit

    def set_limit(self, limit: int):
        self.limit = limit

    def get_offset(self) -> int:
        return self.offset

    def set_offset(self, offset: int):
        self.offset = offset