from dataclasses import dataclass, field

from .step_execution_data import StepExecutionData
from .unmeshed_constants import UnmeshedConstants


@dataclass
class StepData:
    id: int
    process_id: int
    ref: str
    parent_id: int
    parent_ref: str
    namespace: str
    name: str
    type: 'UnmeshedConstants.StepType'
    step_definition_history_id: int
    status: 'UnmeshedConstants.StepStatus'
    input: dict = field(default_factory=dict)
    output: dict = field(default_factory=dict)
    worker_id: str = ''
    start: int = 0
    schedule: int = 0
    priority: int = 0
    updated: int = 0
    optional: bool = False
    execution_list: list['StepExecutionData'] = field(default_factory=list)

    # Getters and Setters

    def get_id(self) -> int:
        return self.id

    def set_id(self, id: int):
        self.id = id

    def get_process_id(self) -> int:
        return self.process_id

    def set_process_id(self, process_id: int):
        self.process_id = process_id

    def get_ref(self) -> str:
        return self.ref

    def set_ref(self, ref: str):
        self.ref = ref

    def get_parent_id(self) -> int:
        return self.parent_id

    def set_parent_id(self, parent_id: int):
        self.parent_id = parent_id

    def get_parent_ref(self) -> str:
        return self.parent_ref

    def set_parent_ref(self, parent_ref: str):
        self.parent_ref = parent_ref

    def get_namespace(self) -> str:
        return self.namespace

    def set_namespace(self, namespace: str):
        self.namespace = namespace

    def get_name(self) -> str:
        return self.name

    def set_name(self, name: str):
        self.name = name

    def get_type(self):
        return self.type

    def set_type(self, type):
        self.type = type

    def get_step_definition_history_id(self) -> int:
        return self.step_definition_history_id

    def set_step_definition_history_id(self, step_definition_history_id: int):
        self.step_definition_history_id = step_definition_history_id

    def get_status(self):
        return self.status

    def set_status(self, status):
        self.status = status

    def get_input(self) -> dict:
        return self.input

    def set_input(self, input_data: dict):
        self.input = input_data

    def get_output(self) -> dict:
        return self.output

    def set_output(self, output_data: dict):
        self.output = output_data

    def get_worker_id(self) -> str:
        return self.worker_id

    def set_worker_id(self, worker_id: str):
        self.worker_id = worker_id

    def get_start(self) -> int:
        return self.start

    def set_start(self, start: int):
        self.start = start

    def get_schedule(self) -> int:
        return self.schedule

    def set_schedule(self, schedule: int):
        self.schedule = schedule

    def get_priority(self) -> int:
        return self.priority

    def set_priority(self, priority: int):
        self.priority = priority

    def get_updated(self) -> int:
        return self.updated

    def set_updated(self, updated: int):
        self.updated = updated

    def is_optional(self) -> bool:
        return self.optional

    def set_optional(self, optional: bool):
        self.optional = optional

    def get_execution_list(self) -> list['StepExecutionData']:
        return self.execution_list

    def set_execution_list(self, execution_list: list['StepExecutionData']):
        self.execution_list = execution_list
