from dataclasses import dataclass, field
from typing import Dict, Optional

@dataclass
class WorkRequest:
    process_id: Optional[int] = field(default=None)
    step_id: int = 0
    step_execution_id: int = 0
    step_name: str = field(default=None)
    step_ref: str = field(default=None)
    step_namespace : str = field(default=None)
    input_param: dict[str, object] = field(default_factory=dict)
    is_optional: bool = field(default=False)
    polled: int = 0
    scheduled: int = 0
    updated: int = 0
    priority: int = 0

    def set_step_namespace(self, step_namespace):
        self.step_namespace = step_namespace

    def get_step_namespace(self) -> str:
        return self.step_namespace

    def get_step_name(self) -> str:
        """Return the step name."""
        return self.step_name

    def get_input_param(self) -> Dict[str, object]:
        """Return the input parameters."""
        return self.input_param
    
    def get_process_id(self) -> int:
        return self.process_id
    
    def get_step_id(self) -> int:
        return self.step_id

    def get_step_execution_id(self) -> int:
        return self.step_execution_id