from dataclasses import dataclass, field
from typing import Any

from .unmeshed_constants import UnmeshedConstants


@dataclass
class WorkResponse:
    _process_id: int = field(default=0)
    _step_id: int = field(default=0)
    _step_execution_id: int = field(default=0)
    _output: dict[str, Any] = field(default_factory=dict)
    _status: str = field(default=UnmeshedConstants.StepStatus.RUNNING.name)
    _reschedule_after_seconds: int = field(default=0)
    _started_at : int = field(default=0)

    # Getter and Setter for process_id
    def get_process_id(self) -> int:
        """Getter for process_id."""
        return self._process_id

    def set_process_id(self, process_id: int) -> None:
        """Setter for process_id."""
        self._process_id = process_id

    # Getter and Setter for step_id
    def get_step_id(self) -> int:
        """Getter for step_id."""
        return self._step_id

    def set_step_id(self, step_id: int) -> None:
        """Setter for step_id."""
        self._step_id = step_id

    # Getter and Setter for step_execution_id
    def get_step_execution_id(self) -> int:
        """Getter for step_execution_id."""
        return self._step_execution_id

    def set_step_execution_id(self, step_execution_id: int) -> None:
        """Setter for step_execution_id."""
        self._step_execution_id = step_execution_id

    # Getter and Setter for output
    def get_output(self) -> dict[str, Any]:
        """Getter for output."""
        return self._output

    def set_output(self, output: dict[str, Any]) -> None:
        """Setter for output."""
        self._output = output

    # Getter and Setter for status
    def get_status(self) -> str:
        """Getter for status."""
        return self._status

    def set_status(self, status: str) -> None:
        """Setter for status."""
        self._status = status

    # Getter and Setter for reschedule_after_seconds
    def get_reschedule_after_seconds(self) -> int:
        """Getter for reschedule_after_seconds."""
        return self._reschedule_after_seconds

    def set_reschedule_after_seconds(self, reschedule_after_seconds: int) -> None:
        """Setter for reschedule_after_seconds."""
        self._reschedule_after_seconds = reschedule_after_seconds

    def set_started_at(self, started_at: int):
        """Setter for reschedule_after_seconds."""
        self._started_at = started_at

    def get_started_at(self) -> int:
        return self._started_at

    def to_dict(self) -> dict[str, Any]:
        """Convert the WorkResponse instance to a dictionary for JSON serialization."""
        return {
            "processId": self._process_id,
            "stepId": self._step_id,
            "startedAt": self._started_at,
            "stepExecutionId": self._step_execution_id,
            "output": self._output,
            "status": self._status.name if self._status else None,  # Ensuring we return the status name
            "rescheduleAfterSeconds": self._reschedule_after_seconds
        }
