from dataclasses import dataclass, field
import time

from .unmeshed_resource_pool import UnmeshedResourcePool
from .work_response import WorkResponse

@dataclass
class WorkResponseTracker:
    work_response: WorkResponse
    retry_count: int = field(default=0)
    queued_time: float = field(default_factory=time.time)
    resource_pool : UnmeshedResourcePool = field(default=None)

    def set_resource_pool(self, resource_pool: UnmeshedResourcePool):
        self.resource_pool = resource_pool
    def get_resource_pool(self) -> UnmeshedResourcePool:
        return self.resource_pool

    def get_work_response(self) -> WorkResponse:
        return self.work_response

    def set_work_response(self, work_response: WorkResponse):
        self.work_response = work_response

    def get_retry_count(self):
        return self.retry_count

    def set_retry_count(self, count: int):
        self.retry_count = count

    def get_queued_time(self):
        return self.queued_time

    def set_queued_time(self, queued_time: float):
        self.queued_time = queued_time
