from functools import wraps

def worker_function(name, namespace="default", max_in_progress=1, io_thread=False, domain=""):
    def decorator(func):
        @wraps(func)
        def wrapper(*args, **kwargs):
            # You can add logic here to handle the function's execution
            return func(*args, **kwargs)

        # Store the metadata as attributes of the decorated function
        wrapper.worker_function_metadata = {
            "name": name,
            "namespace": namespace,
            "max_in_progress": max_in_progress,
            "io_thread": io_thread,
            "domain": domain
        }

        return wrapper

    return decorator